# pre:  organize and organize_48x48_comparison were run
#       to get REPORT-* and calculated/48x48responders.csv
#       like many other files, this also relies on sample/bear_round*.apredictions
#       which came from the active learner; the "sample" prefix is just because
#       of the way the data were copied around
#       also: for the extra lines analysis, special/looking_for_the_two/20130525.for_two/execution_wrapper.py
#       had to been called
import numpy
import os
import string

if not os.path.exists('results'):
    mkdir('results')

import matplotlib
# Force matplotlib to not use any Xwindows backend.
matplotlib.use('Agg')

# import matplotlib as mpl
# mpl.rcParams['pdf.fonttype'] = 42

import pylab
import matplotlib.pyplot as plt

params = {'backend': 'ps',
           'axes.labelsize': 10,
           'text.fontsize': 10,
           'legend.fontsize': 10,
           'xtick.labelsize': 8,
           'ytick.labelsize': 8}
pylab.rcParams.update(params)


data = []
actual_observations = []
structure = []
quads_hit = []
kind_of_quads = numpy.zeros((32, 5))
quads_at = numpy.zeros((48,48))
num_phenos_per_round = []
odump = {}
for i in range(1,31):
    odump[i] = []
    z = open('calculated/REPORT-'+str(i)+'.csv','r')
    for rline in z:
        data.append([float(x) for x in string.split(rline.rstrip())])
    c = 0
    qhit = set([])
    pppp = set([])
    ap = open('sample/bear_round'+str(i)+'.apredictions','r')
    quads_at[:] = 0
    arrangement = numpy.zeros((96,96))
    for rline in ap:
        Line = string.split(rline.rstrip())
        arrangement[int(Line[0])-1, int(Line[1])-1] = int(Line[2])
        if '1' in Line[4]:
            c += 1
            qhit.add(((int(Line[0])-1)%48+1, (int(Line[1])-1)%48+1))
            quads_at[(int(Line[0])-1)%48,(int(Line[1])-1)%48] += 1
            pppp.add(int(Line[2]))
            odump[i].append([int(Line[0]), int(Line[1]),int(Line[2])])
    num_phenos_per_round.append(len(pppp))
    kind_of_quads[i,0] = numpy.where(quads_at==0)[0].shape[0]
    kind_of_quads[i,1] = numpy.where(quads_at==1)[0].shape[0]
    kind_of_quads[i,2] = numpy.where(quads_at==2)[0].shape[0]
    kind_of_quads[i,3] = numpy.where(quads_at==3)[0].shape[0]
    kind_of_quads[i,4] = numpy.where(quads_at==4)[0].shape[0]
    quads_hit.append(len(qhit))
    actual_observations.append(float(c))
    rowacc = 0
    colacc = 0
    odump[i] = numpy.asarray(odump[i])
    for ii in range(0,47):
        colacc += numpy.where(arrangement[ii,:]==arrangement[ii+48,:])[0].shape[0]
        rowacc += numpy.where(arrangement[:,ii]==arrangement[:,ii+48])[0].shape[0]
    structure.append((rowacc,colacc))






data = numpy.asarray(data)
actual_observations = numpy.asarray(actual_observations, dtype='i2')
actual_observations_scaled1 = actual_observations / float(96*96)

rowaccs, colaccs = zip(*structure)
rowaccs = numpy.asarray(rowaccs)
colaccs = numpy.asarray(colaccs)

#
# Number of phenotypes as a function of #experiments
#
pylab.plot(actual_observations_scaled1, num_phenos_per_round, 'k.-')
pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Number of Phenotypes')
pylab.savefig('results/Figure S4.png')
pylab.clf(); pylab.close()



#
# Quads hit
#

ax = pylab.subplot(1,1,1)
ax.plot(actual_observations_scaled1, numpy.asarray(quads_hit)/(48*48.0), 'k.-')
pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Fraction Unique Experiments (48x48) Observed')
pylab.savefig('results/fraction_quads_hit.png')
pylab.clf(); pylab.close()



#
# Generalization accuracy (with trend lines)
#

theindices = numpy.load('calculated/indices.npy')
total_obs = set([])
for i in range(theindices.shape[0]):
    if theindices[i,1] <= 96:
        total_obs.add((theindices[i,0], theindices[i,1]))

pylab.plot(actual_observations_scaled1, (actual_observations+data[:,1])/len(total_obs),'k.-')
# for i in range(10,110,10):
#     pylab.plot(actual_observations_scaled1, (actual_observations+(len(total_obs)-actual_observations)*float(i)/100.0)/len(total_obs),':', color='gray')

pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Accuracy')
pylab.ylim([0,1])
pylab.savefig('results/generalization_accuracy.png')
pylab.clf(); pylab.close()


#
# Generalization accuracy + Model Fit
#

M = kind_of_quads[1:-1,:]

# now with better units
MM = M/numpy.sum(M,axis=1)[:,numpy.newaxis]
beta, residuals, rank, sing = numpy.linalg.lstsq(MM, data[:,1]/data[:,2])

fout = open('THINGS_FOR_PAPER.txt','a')
fout.write('The regression model fit (essentially Figure 2) loadings are '+' '.join([str(x) for x in beta])+"\n")
fout.close()

coverage_model_predictions = (numpy.dot(MM,beta)*(len(total_obs)-actual_observations)+actual_observations)/len(total_obs)
pylab.plot(actual_observations_scaled1, coverage_model_predictions,'b.-')
pylab.plot(actual_observations_scaled1, (actual_observations+data[:,1])/len(total_obs),'k.-')
pylab.ylim([0,1])
pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Accuracy')
pylab.savefig('results/generalization_accuracy_model.png')
pylab.clf(); pylab.close()


#
# Construct Random Fit
#
import scipy.stats
if os.path.exists('calculated/pred_random.npy'):
    pred_random = numpy.load('calculated/pred_random.npy')
else:
    pred_random = numpy.zeros((actual_observations_scaled1.shape[0],2))
    while not numpy.all(numpy.diff(pred_random[:,0])>0):
        niter = 10000
        assortment = numpy.zeros((niter,5))
        random_coverage = numpy.zeros((niter,))
        for i in range(niter):
            assortment[i,:] = numpy.random.randint(0,48*48, size=5)
            random_coverage[i] = numpy.dot(assortment[i,:],[0,1,2,3,4])
            while (numpy.sum(assortment[i,:]) > 48*48) or (random_coverage[i]>2304) or (assortment[i,4]>assortment[i,3]):
                assortment[i,:] = numpy.random.randint(0,48*48, size=5)
                random_coverage[i] = numpy.dot(assortment[i,:],[0,1,2,3,4])
            print i
        #
        whoop = numpy.zeros((niter,2))
        whoop[:,0] = random_coverage/(96*96)
        whoop[:,1] = (random_coverage+numpy.dot(assortment, beta))/len(total_obs)
        #
        samples = numpy.linspace(0,1,num=100)
        for ii in range(actual_observations_scaled1.shape[0]):
            i = actual_observations_scaled1[ii]
            kernel = scipy.stats.gaussian_kde(whoop[numpy.where(numpy.abs(whoop[:,0]-i)<0.05),1])
            kvs = kernel(samples)
            pred_random[ii,0] = numpy.dot(samples,kvs)/numpy.sum(kvs)
            pred_random[ii,1] = numpy.var(samples*kvs)
    #
    numpy.save('calculated/pred_random.npy', pred_random)


#
# Generalization accuracy + Model Fit + Random Proxy
#

pylab.plot(actual_observations_scaled1, coverage_model_predictions,'b.-')
pylab.plot(actual_observations_scaled1, (actual_observations+data[:,1])/len(total_obs),'k.-')
pylab.plot(actual_observations_scaled1, pred_random[:,0],'r.-')
# Bob said to remove
# for i in range(10,110,10):
#     pylab.plot(actual_observations_scaled1, (actual_observations+(len(total_obs)-actual_observations)*float(i)/100.0)/len(total_obs),':', color='gray')

pylab.ylim([0,1])
pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Accuracy')
#pylab.savefig('results/generalization_accuracy_model_random.png')
pylab.savefig('results/Figure 2.png')
pylab.clf(); pylab.close()



#
# Generalization accuracy (proportions)
#
pylab.plot(actual_observations_scaled1, data[:,1]/data[:,2],'b.-')
for i in range(actual_observations.shape[0]):
    pylab.plot([actual_observations_scaled1[i], actual_observations_scaled1[i]], [data[i,4], data[i,6]], 'k-')
    pylab.plot(actual_observations_scaled1[i], data[i,5], 'ko')

pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Generalization Accuracy')
pylab.savefig('results/generalization_accuracy_proportions.png')
pylab.clf(); pylab.close()



#
# Generalization accuracy against extra lines accuracy
#
# special/looking_for_the_two/20130525.for_two/execution_wrapper.py
# extra_accs = numpy.loadtxt('special/RESULTS-extra-phenotype-predictions-match.csv')
#

# Multinomial class code from: http://stackoverflow.com/a/13974527
import math

class Multinomial(object):
  def __init__(self, params):
    self._params = params

  def pmf(self, counts):
    if not(len(counts)==len(self._params)):
      raise ValueError("Dimensionality of count vector is incorrect")

    prob = 1.
    for i,c in enumerate(counts):
      prob *= self._params[i]**counts[i]

    return prob * math.exp(self._log_multinomial_coeff(counts))

  def log_pmf(self,counts):
    if not(len(counts)==len(self._params)):
      raise ValueError("Dimensionality of count vector is incorrect")

    prob = 0.
    for i,c in enumerate(counts):
      prob += counts[i]*math.log(self._params[i])

    return prob + self._log_multinomial_coeff(counts)

  def _log_multinomial_coeff(self, counts):
    return self._log_factorial(sum(counts)) - sum(self._log_factorial(c) for c in counts)

  def _log_factorial(self, num):
    if not round(num)==num and num > 0:
      raise ValueError("Can only compute the factorial of positive ints")
    return sum(math.log(n) for n in range(1,num+1))

def extra_line_accuracy():
    actual_phenotypes = numpy.loadtxt('calculated/POSTHOC-round-30-extraphenotypes.txt')
    myline_lookup = {}
    myline_lookup[101] = 97
    myline_lookup[102] = 98
    myline_lookup[103] = 99
    myline_lookup[104] = 100
    myline_lookup[105] = 101
    myline_lookup[107] = 102
    for i in range(1,97):
        myline_lookup[i] = i
    actual_phenotypes[:,1] = [myline_lookup[x] for x in actual_phenotypes[:,1]]
    predicted_phenotypes = numpy.loadtxt('special/looking_for_the_two/round30/EXTRATITLE.apredictions')[:,:3]
    predicted_helper = { (x[0],x[1]) : x[2] for x in predicted_phenotypes } 
    per_pheno_counts = numpy.bincount(arrangement.flatten().astype('int'))
    total_pheno_counts = float(numpy.sum(per_pheno_counts))
    reorder = { x : ii for (ii,x) in enumerate(numpy.nonzero(per_pheno_counts)[0]) }
    q= per_pheno_counts/total_pheno_counts
    r = numpy.zeros((len(q[q>0]),), dtype='int')
    for x in actual_phenotypes:
        r[reorder[x[2]]] += 1
    m = Multinomial(q[q>0])
    by_drug_guess = 0.0
    for d in range(1,49):
        bulk = numpy.bincount(arrangement[d-1,:].astype('int'))
        within = numpy.bincount(actual_phenotypes[actual_phenotypes[:,0]==d,2].astype('int'), minlength=bulk.shape[0])
        by_drug_guess += numpy.dot(bulk/48.0, within)
    by_drug_guess /= (6*48)
    guess_unperturbed = 0.0
    for i in [97,98,99,100,101,102]:
        subs = actual_phenotypes[actual_phenotypes[:,1]==i]
        guess_unperturbed += numpy.sum(subs[subs[:,0]==48,2][0]==subs[subs[:,0]!=48,2])
    guess_unperturbed /= 6*47
    return numpy.sum([predicted_helper[x[0],x[1]]==x[2] for x in actual_phenotypes])/(6*48.), m.pmf(r), by_drug_guess, guess_unperturbed



# pylab.plot(actual_observations_scaled1, (actual_observations+data[:,1])/len(total_obs),'k.-')
# pylab.plot(actual_observations_scaled1, extra_accs[:,1]/(6*48), 'b.-')

# pylab.xlabel('Experiment Space Coverage')
# pylab.ylabel('Accuracy')
# pylab.ylim([0,1])
# pylab.savefig('results/generalization_accuracy_against_extra_lines.png')
# pylab.clf(); pylab.close()


fout = open('THINGS_FOR_PAPER.txt','a')
# fout.write('The final model for the extra lines had an accuracy of '+str((extra_accs[:,1]/(6*48))[-1])+"\n")
extra_acc, extra_null, by_drug_guess, guess_unperturbed = extra_line_accuracy()
fout.write('The final model for the extra lines had an accuracy of '+str(extra_acc)+' P=' +str(extra_null)+"\n")
fout.write('...additionally, by guessing using per-drug distributions a random null accuracy would be '+str(by_drug_guess)+"\n")
fout.write('...additionally, by guessing unperturbed every time, a random null accuracy would be '+str(guess_unperturbed)+"\n")
fout.close()



#
# Coverage regression to number of phenotypes
# 

beta2, residuals, rank, sing = numpy.linalg.lstsq(MM, num_phenos_per_round)

fout = open('THINGS_FOR_PAPER.txt','a')
fout.write('The regression model fit against number of phenotypes loadings are '+' '.join([str(x) for x in beta2])+"\n")
fout.close()

coverage_model_predictions = numpy.dot(MM,beta2)
pylab.plot(actual_observations_scaled1, num_phenos_per_round,'k.-')
pylab.plot(actual_observations_scaled1, coverage_model_predictions,'b.-')
pylab.xlabel('Experiment Space Coverage')
pylab.ylabel('Number of Phenotypes')
pylab.savefig('results/num_phenos_per_round_model.png')
pylab.clf(); pylab.close()

