import numpy
import xlwt
import string

posthoc_data = numpy.load('calculated/rawdata_posthoc.npy')
posthoc_indices = numpy.load('calculated/indices_posthoc.npy')


print 'building exp_to_range differently'
posthoc_exp_to_range = {}
for i in range(posthoc_indices.shape[0]):
	if (posthoc_indices[i,0], posthoc_indices[i,1]) not in posthoc_exp_to_range:
		posthoc_exp_to_range[(posthoc_indices[i,0], posthoc_indices[i,1])] = []
	posthoc_exp_to_range[(posthoc_indices[i,0], posthoc_indices[i,1])].append(i)


data = numpy.load('calculated/rawdata.npy')
indices = numpy.load('calculated/indices.npy')

print 'building exp_to_range differently'
exp_to_range = {}
for i in range(indices.shape[0]):
	if (indices[i,0], indices[i,1]) not in exp_to_range:
		exp_to_range[(indices[i,0], indices[i,1])] = []
	exp_to_range[(indices[i,0], indices[i,1])].append(i)


mergewb = xlwt.Workbook()
ws = mergewb.add_sheet('mean features')
ws.write(0, 0, 'Drug ID')
ws.write(0, 1, 'Clone ID')
ws.write(0, 2, 'Round Measured')
j = 3
for i in range(30):
	ws.write(0,j, 'Phenotype in Round '+str(i))
	j += 1

for i in range(data.shape[1]):
	ws.write(0,j, 'SLF34.'+str(i+1))
	j += 1


phenotype_assignment_trace = {}
first_observed = {}
already_observed_experiments = set([])
for which_round in range(1,31):
	ap = open('sample/bear_round'+str(which_round)+'.apredictions','r')
	observed_experiments = []
	for rline in ap:
		Line = string.split(rline.rstrip())
		place = (int(Line[0]), int(Line[1]))
		if place not in phenotype_assignment_trace:
			phenotype_assignment_trace[place] = []
		phenotype_assignment_trace[place].append(int(Line[2]))
		if '1' in Line[4]:
			if place not in already_observed_experiments:
				first_observed[place] = which_round
				already_observed_experiments.add(place)

ii = 1
for e in first_observed.keys():
	ws.write(ii,0, e[0])
	ws.write(ii,1, e[1])
	ws.write(ii,2, first_observed[e])
	j = 3
	for v in phenotype_assignment_trace[e]:
		ws.write(ii,j, v)
		j += 1

	if e not in set(first_observed.keys())-set(exp_to_range.keys()):
		mvec = numpy.mean(data[exp_to_range[e],:],axis=0)
		for i in range(data.shape[1]):
			ws.write(ii,j, mvec[i])
			j += 1
	else:
		# round 15 screwup
		for i in range(data.shape[1]):
			ws.write(ii,j, numpy.nan)
			j += 1

	ii += 1

mergewb.save('dataset.xls')


# it's easier to add the other spreadsheet generation code to phenotype_analysis_posthoc.py, so it's there
