#!/home/awn/tools/bin/python
#import cv2
import numpy
import sys
import os
import string
import scipy.stats
import random
import ic100
import scipy
import scipy.misc
import scipy.ndimage
import itertools
import scipy.spatial

os.chdir('/home/twoactive/filtering')


field_lookup = []
smpl_field_lookup = {}
i = 0
for line in open('sample/FULLDATA_field_info.txt'):
    field_lookup.append(line.rstrip())
    smpl_field_lookup[string.split(field_lookup[-1],'/')[-1]] = i
    i += 1


rev_field_lookup = {}
exp_to_field = {}
z = numpy.load('sample/FULLDATA_exp_labels.npy')
for i in range(z.shape[0]):
    x = (numpy.mod(int(z[i,0])-1,48)+1, numpy.mod(int(z[i,1])-1,48)+1)
    if x not in exp_to_field:
        exp_to_field[x] = []
    exp_to_field[x].append(i)
    rev_field_lookup[i] = x


def kdist(bw,axs,ays):
    if ays.shape[0] < axs.shape[0]:
        ys = axs
        xs = ays
    else:
        ys = ays
        xs = axs        
    acc = 0.0
    inv_sq_bw = -0.5/bw**2
    dd = numpy.zeros(ys.shape)
    for i in range(xs.shape[0]):
        dd[:] = ys[:]
        dd -= xs[i,:]
        acc += numpy.sum(numpy.exp(inv_sq_bw*numpy.sum(dd**2,axis=1)))
    return acc/(xs.shape[0]*ys.shape[0])

def fullmmdl(bw,xs,ys):
    return kdist(bw,xs,xs)+kdist(bw,ys,ys)-2.0*kdist(bw,xs,ys)


def rawmmdl(bw,xs,ys):
    touched_xs = set([])
    touched_ys = set([])
    acc = 0.0
    inv_sq_bw = 1.0/bw**2
    maxiter = min(ys.shape[0],xs.shape[0])/2
    if maxiter > 1:
        for ii in range(maxiter):
                x1 = numpy.random.randint(0,xs.shape[0])
                while x1 in touched_xs:
                        x1 = numpy.random.randint(0,xs.shape[0])
                touched_xs.add(x1)
                x2 = numpy.random.randint(0,xs.shape[0])
                while x2 in touched_xs:
                        x2 = numpy.random.randint(0,xs.shape[0])
                touched_xs.add(x2)
                y1 = numpy.random.randint(0,ys.shape[0])
                while y1 in touched_ys:
                        y1 = numpy.random.randint(0,ys.shape[0])
                touched_ys.add(y1)
                y2 = numpy.random.randint(0,ys.shape[0])
                while y2 in touched_ys:
                        y2 = numpy.random.randint(0,ys.shape[0])
                touched_ys.add(y2)
                acc += numpy.exp(-0.5*numpy.sum((xs[x1,:]-xs[x2,:])**2)*inv_sq_bw)
                acc += numpy.exp(-0.5*numpy.sum((ys[y1,:]-ys[y2,:])**2)*inv_sq_bw)
                acc -= numpy.exp(-0.5*numpy.sum((xs[x1,:]-ys[y2,:])**2)*inv_sq_bw)
                acc -= numpy.exp(-0.5*numpy.sum((xs[x2,:]-ys[y1,:])**2)*inv_sq_bw)
        return acc/maxiter
    else:
        return numpy.nan

def mmdl(bw,xs,ys):
    z = rawmmdl(bw,xs,ys)
    while z < 0:
        z = rawmmdl(bw,xs,ys)
    return z

# ppv = []
# for i,j in itertools.combinations(range(len(acc)),2):
#     print i,j
#     ppv.append(numpy.abs(fullmmdl(1.0,acc[i],acc[j])))

# ok so I think the plan should be:
# see if a crude segmentation around nuclei (sort of following the)
# windowing code way below gives similar surf feature sets
# as just doing it on the whole field
# I am guessing it won't
# then we need to see if any of the surf observations are correlated
# with the observable, "is this cell any good or is it crap?"
# I then need to calculate a per-field, "what fraction of cells in this field are good"
# which is probably easier to validate than isolated cells
# the next question then is how will I identify decent fields overall


#markedbad = ['filter/surfcache/'+'.'.join(x.split('.')[-3:]) for x in os.listdir('filter/bad') if '.npy' in x[-4:]]
markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedbad.append('filter/surfcache/'+x)

# rootkept = [x for x in os.listdir('filter/keep') if '.npy' in x[-4:]]
# kept = ['.'.join(x.split('.')[-3:-1]) for x in rootkept]
# markedgood = ['filter/surfcache/'+'.'.join(x.split('.')[-3:-1])+'.npy' for x in os.listdir('filter/good') if '.npy' in x[-4:]]+['filter/surfcache/'+'.'.join(x.split('.')[-3:-1])+'.npy' for x in rootkept]

markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedgood.append('filter/surfcache/'+x)

probablywtf = set(markedgood) & set(markedbad)

datagood = [numpy.load(x) for x in markedgood if x not in probablywtf]
databad = [numpy.load(x) for x in markedbad if x not in probablywtf]
databad = [x for x in databad if x.shape[0] > 5]

yaybandwidth = float(numpy.load('best-bandwidth.npy'))
print 'bandwidth is', yaybandwidth

#remaining_experiments = exp_to_field.keys()
#random.shuffle(remaining_experiments)

mydrug = int(os.environ['WDRUG'])
myprot = int(os.environ['WPROT'])

e = (mydrug,myprot)

# remaining_experiments = exp_to_field.keys()
# random.shuffle(remaining_experiments)

# force this one to the head
remaining_experiments = [e]#+remaining_experiments
print 'about to start'
for ei,e in enumerate(remaining_experiments):
    if not os.path.exists('d'+str(e[0])+'-p'+str(e[1])+'.marking'):
        print ei, e
        fout = open('d'+str(e[0])+'-p'+str(e[1])+'.marking','w')
        tacc = [field_lookup[x] for x in exp_to_field[e]]
        besti = None
        bestv = numpy.inf
        for fi,f in enumerate(tacc):
            print fi, len(tacc)
            rname = '.'.join(f.split('/')[-1:])+'.npy'
            surfname = 'filter/surfcache/'+rname
            if not os.path.exists('/scratch/'+rname):
                if os.path.exists(surfname):
                    os.system('cp '+surfname+' /scratch/'+rname)
                else:
                    continue
            field_data_green = numpy.load('/scratch/'+rname)
            if field_data_green.shape[0] > 0:
                gd = [mmdl(yaybandwidth, field_data_green, x) for x in datagood]
                bd = [mmdl(yaybandwidth, field_data_green, x) for x in databad]
                gdm = numpy.nanmin(gd)
                bdm = numpy.nanmin(bd)
                delta = gdm-bdm
                if not numpy.isnan(delta):
                    if delta < bestv:
                        bestv = delta
                        besti = f
                    fout.write(f+' '+str(gdm)+' '+str(bdm)+"\n")
        fout.close()

print 'finished'
