#!/home/awn/tools/bin/python
#import cv2
import numpy
import sys
import os
import string
import scipy.stats
import random
import ic100
import scipy
import scipy.misc
import scipy.ndimage
import itertools
import scipy.spatial

os.chdir('/home/twoactive/filtering')


field_lookup = []
smpl_field_lookup = {}
i = 0
for line in open('sample/FULLDATA_field_info.txt'):
    field_lookup.append(line.rstrip())
    smpl_field_lookup[string.split(field_lookup[-1],'/')[-1]] = i
    i += 1


rev_field_lookup = {}
exp_to_field = {}
z = numpy.load('sample/FULLDATA_exp_labels.npy')
for i in range(z.shape[0]):
    x = (numpy.mod(int(z[i,0])-1,48)+1, numpy.mod(int(z[i,1])-1,48)+1)
    if x not in exp_to_field:
        exp_to_field[x] = []
    exp_to_field[x].append(i)
    rev_field_lookup[i] = x

crazybad = []
for z in open('verybad.txt','r'):
    crazybad.append(z.rstrip().replace('.png', '.npy'))

crazybad = set(crazybad)

def kdist(bw,axs,ays):
    if ays.shape[0] < axs.shape[0]:
        ys = axs
        xs = ays
    else:
        ys = ays
        xs = axs        
    acc = 0.0
    inv_sq_bw = -0.5/bw**2
    dd = numpy.zeros(ys.shape)
    for i in range(xs.shape[0]):
        dd[:] = ys[:]
        dd -= xs[i,:]
        acc += numpy.sum(numpy.exp(inv_sq_bw*numpy.sum(dd**2,axis=1)))
    return acc/(xs.shape[0]*ys.shape[0])

def mmdl(bw,xs,ys):
    acc = 0.0
    multi = -0.5/bw**2
    maxiter = min(ys.shape[0],xs.shape[0])/2
    for i in range(maxiter):
        x1 = 2*i
        x2 = 2*i+1
        y1 = 2*i
        y2 = 2*i+1
        acc += numpy.exp(multi*numpy.sum((xs[x1,:]-xs[x2,:])**2))
        acc += numpy.exp(multi*numpy.sum((ys[y1,:]-ys[y2,:])**2))
        acc -= numpy.exp(multi*numpy.sum((xs[x1,:]-ys[y2,:])**2))
        acc -= numpy.exp(multi*numpy.sum((xs[x2,:]-ys[y1,:])**2))
    return acc/maxiter

markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip().replace('.png', '')
    markedbad.append(x)


markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip().replace('.png', '')
    markedgood.append(x)

yaybandwidth = float(numpy.load('best-bandwidth.npy'))
print 'bandwidth is', yaybandwidth

#remaining_experiments = exp_to_field.keys()
#random.shuffle(remaining_experiments)

mydrug = int(os.environ['WDRUG'])
myprot = int(os.environ['WPROT'])

e = (mydrug,myprot)

examples_of_good_for_e = [f for f in markedgood if rev_field_lookup[smpl_field_lookup[f]] == e]
examples_of_bad_for_e = [f for f in markedbad if rev_field_lookup[smpl_field_lookup[f]] == e]

def myload(x):
    if os.path.exists('/scratch/'+x):
        return numpy.load('/scratch/'+x)
    else:
        return numpy.load('filter/surfcache/'+x)

#if len(examples_of_good_for_e)>1 and len(examples_of_bad_for_e)>1:
if len(examples_of_good_for_e)>1:
    print 'using only subset', len(examples_of_good_for_e), len(examples_of_bad_for_e)
    datagood = [myload(x+'.npy') for x in examples_of_good_for_e if os.path.exists(x+'.npy')]
    databad = [myload(x+'.npy') for x in examples_of_bad_for_e if os.path.exists(x+'.npy')]
else:
    print 'using full data'
    datagood = [myload(x+'.npy') for x in markedgood if os.path.exists(x+'.npy')]
    databad = [myload(x+'.npy') for x in markedbad if os.path.exists(x+'.npy')]

datagood = [x for x in datagood if x.shape[0]>2]
databad = [x for x in databad if x.shape[0]>2]


# remaining_experiments = exp_to_field.keys()
# random.shuffle(remaining_experiments)

def mymmdl(bw,me_to_myself,xs,ys):
    if ys.shape[0] > 32:
        return numpy.abs(mmdl(bw,xs,ys))
    else:
        return numpy.abs(me_to_myself+kdist(bw,ys,ys)-2.0*kdist(bw,xs,ys))

if not os.path.exists('d'+str(e[0])+'-p'+str(e[1])+'.marking'):
    fout = open('d'+str(e[0])+'-p'+str(e[1])+'.marking','w')
    tacc = [field_lookup[x] for x in exp_to_field[e]]
    for fi,f in enumerate(tacc):
        print fi, len(tacc)
        justnameugh = f.split('/')[-1]
        if justnameugh not in crazybad:
            if justnameugh in examples_of_good_for_e:
                fout.write(f+' 0 1 0 1 0'+"\n")
            elif justnameugh in examples_of_bad_for_e:
                fout.write(f+' 1 0 1 0 0'+"\n")
            else:
                rname = justnameugh+'.npy'
                surfname = 'filter/surfcache/'+rname
                if not os.path.exists('/scratch/'+rname):
                    if os.path.exists(surfname):
                        os.system('cp '+surfname+' /scratch/'+rname)
                    else:
                        continue
                field_data_green = numpy.load('/scratch/'+rname)
                if field_data_green.shape[0] > 0:
                    me_to_myself = kdist(yaybandwidth,field_data_green,field_data_green)
                    if ( len(datagood)>0 ) and ( len(databad) > 0 ):
                        gd = [mymmdl(yaybandwidth, me_to_myself, field_data_green, x) for x in datagood]
                        bd = [mymmdl(yaybandwidth, me_to_myself, field_data_green, x) for x in databad]
                        gdm = numpy.min(gd)
                        bdm = numpy.min(bd)
                        fout.write(f+' '+' '.join([str(x) for x in [numpy.min(gd), numpy.min(bd), numpy.max(gd), numpy.max(bd), 0]])+"\n")
                    else:
                        fout.write(f+' '+' '.join([str(x) for x in [1, 0, 1, 1, 1]])+"\n")
    fout.close()

print 'finished'
