#!/home/awn/tools/bin/python
import cv2
import numpy
import sys
import os
import string
import scipy.stats
import random
import ic100
import scipy
import scipy.misc
import scipy.ndimage
import itertools
import scipy.spatial
import pyslic

os.chdir('/home/twoactive/filtering')

# field_lookup = []
# smpl_field_lookup = {}
# i = 0
# for line in open('sample/FULLDATA_field_info.txt'):
#     field_lookup.append(line.rstrip())
#     smpl_field_lookup[string.split(field_lookup[-1],'/')[-1]] = i
#     i += 1

field_lookup = []
smpl_field_lookup = {}
i = 0
for line in open('/home/active/internal/experiments/images/allimages.txt'):
    lline = '/home/active/internal/experiments/images/'+line.rstrip()
    field_lookup.append(lline)
    smpl_field_lookup[string.split(line,'/')[-1]] = i
    i += 1


CACHED_IMAGES = set(os.listdir('image_cache'))
def gimme_image(f):
    outimg = numpy.zeros((1024,1344,3), dtype='uint16')
    broken = string.split(f,'/')
    if broken[-1]+'.png' not in CACHED_IMAGES:
        print '**** fetching image'
        bluename = f
        outimg[:,:,2] = ic100.read_ic100_BMP(bluename)
        outimg[:,:,1] = ic100.read_ic100_BMP(bluename.replace('ch_00', 'ch_01'))
        for i in range(1,3):
            outimg[:,:,i] -= numpy.min(outimg[:,:,i])
            outimg[:,:,i] *= 4095.0/float(numpy.max(outimg[:,:,i]))
        scipy.misc.imsave('image_cache/'+broken[-1]+'.png', outimg)
        CACHED_IMAGES.add(broken[-1]+'.png')
    else:
        outimg = scipy.misc.imread('image_cache/'+broken[-1]+'.png')
    if len(outimg.shape)==0:
        # some files got corrupted in the transfer from the server?  fix on the next pass
        print 'blowing away ', 'image_cache/'+broken[-1]+'.png'
        os.remove('image_cache/'+broken[-1]+'.png')
        CACHED_IMAGES.remove(broken[-1]+'.png')
    return outimg


def cv_gimme_image(f):
    outimg = numpy.zeros((1024,1344,3), dtype='uint16')
    broken = string.split(f,'/')
    if broken[-1]+'.png' not in CACHED_IMAGES:
        print '**** fetching image'
        bluename = f
        outimg[:,:,2] = ic100.read_ic100_BMP(bluename)
        outimg[:,:,1] = ic100.read_ic100_BMP(bluename.replace('ch_00', 'ch_01'))
        for i in range(1,3):
            outimg[:,:,i] -= numpy.min(outimg[:,:,i])
            outimg[:,:,i] *= 4095.0/float(numpy.max(outimg[:,:,i]))
        scipy.misc.imsave('image_cache/'+broken[-1]+'.png', outimg)
    #
    return cv2.imread('image_cache/'+broken[-1]+'.png')



#SURFCACHED = set(os.listdir('filter/surfcache'))
random.shuffle(field_lookup)
for idx in range(len(field_lookup)):
    baseimgname = field_lookup[idx].split('/')[-1]
    if not os.path.exists('filter/surfcache/'+baseimgname+'.npy'):
        print idx, len(field_lookup)
        #try:
        aa = cv_gimme_image(field_lookup[idx])
        if aa is not None:
            cnuc = pyslic.segmentation.nucleicof(aa[:,:,0])
            surf = cv2.SURF()
            # change necessary for different opencv version because everyone is a jackass and changes their fucking apis for no good reason.
            kps, desc = surf.detectAndCompute(aa[:,:,1].copy(),None)
            imgloaded = True
            if desc is not None:
                # they also went from 128-element vectors to 64-element vectors. why.
                field_data_green = desc #numpy.reshape(desc,(desc.shape[0]/128,128))
                karr = numpy.asarray([k.pt for k in kps])
                pass_closeness_threshold = numpy.min(scipy.spatial.distance.cdist(karr, numpy.asarray([[c[1],c[0]] for c in cnuc])),axis=1)<150
                pass_size_threshold = numpy.asarray([k.size for k in kps])<150
                passing = numpy.logical_and(pass_closeness_threshold,pass_size_threshold)
                field_data_green = field_data_green[passing,:]
                numpy.save('filter/surfcache/'+baseimgname+'.npy', field_data_green)