#!/opt/python27/bin/python
import numpy
import sys
import os
import string
import random
import itertools

os.chdir('/home/twoactive/filtering')

def kdist(bw,axs,ays):
    if ays.shape[0] < axs.shape[0]:
        ys = axs
        xs = ays
    else:
        ys = ays
        xs = axs        
    acc = 0.0
    inv_sq_bw = -0.5/bw**2
    dd = numpy.zeros(ys.shape)
    for i in range(xs.shape[0]):
        dd[:] = ys[:]
        dd -= xs[i,:]
        acc += numpy.sum(numpy.exp(inv_sq_bw*numpy.sum(dd**2,axis=1)))
    return acc/(xs.shape[0]*ys.shape[0])

def mmdl(bw,xs,ys):
    acc = 0.0
    multi = -0.5/bw**2
    maxiter = min(ys.shape[0],xs.shape[0])/2
    for i in range(maxiter):
        x1 = 2*i
        x2 = 2*i+1
        y1 = 2*i
        y2 = 2*i+1
        acc += numpy.exp(multi*numpy.sum((xs[x1,:]-xs[x2,:])**2))
        acc += numpy.exp(multi*numpy.sum((ys[y1,:]-ys[y2,:])**2))
        acc -= numpy.exp(multi*numpy.sum((xs[x1,:]-ys[y2,:])**2))
        acc -= numpy.exp(multi*numpy.sum((xs[x2,:]-ys[y1,:])**2))
    return acc/maxiter

markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedbad.append(x)

markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedgood.append(x)

probablywtf = set(markedgood) & set(markedbad)

print 'probablywtf should be empty', probablywtf

whoami = os.environ['WINSTANCE']

matchname = whoami[:-4]+'.npy'

datagood = []
for x in markedgood:
    if ( x not in probablywtf ) and ( x != matchname ):
        if not os.path.exists('/scratch/'+x):
            if os.path.exists('filter/surfcache/'+x):
                print 'copying'
                os.system('cp filter/surfcache/'+x+' /scratch/'+x)
            else:
                continue
        datagood.append(numpy.load('/scratch/'+x))


databad = []
for x in markedbad:
    if ( x not in probablywtf ) and ( x != matchname ):
        if not os.path.exists('/scratch/'+x):
            if os.path.exists('filter/surfcache/'+x):
                print 'copying'
                os.system('cp filter/surfcache/'+x+' /scratch/'+x)
            else:
                continue
        databad.append(numpy.load('/scratch/'+x))

rname = matchname
surfname = 'filter/surfcache/'+rname
if not os.path.exists('/scratch/'+rname):
    if os.path.exists(surfname):
        os.system('cp '+surfname+' /scratch/'+rname)


field_data_green = numpy.load('/scratch/'+rname)

possible_bws = numpy.load('possible_bws.npy')

def mymmdl(bw,me_to_myself,ys):
    if ys.shape[0] > 32:
        return mmdl(bw,field_data_green,ys)
    else:
        return me_to_myself+kdist(bw,ys,ys)-2.0*kdist(bw,field_data_green,ys)

if not os.path.exists('bandwidths/'+whoami+'.bandwidth'):
    fout = open('bandwidths/'+whoami+'.bandwidth','w')
    for bw in possible_bws:
        print bw
        me_to_myself = kdist(bw,field_data_green,field_data_green)
        gd = [mymmdl(bw, me_to_myself, x) for x in datagood]
        bd = [mymmdl(bw, me_to_myself, x) for x in databad]
        gdm = numpy.nanmin(numpy.abs(gd))
        bdm = numpy.nanmin(numpy.abs(bd))
        delta = gdm-bdm
        fout.write(str(bw)+' '+str(gdm)+' '+str(bdm)+"\n")

    fout.close()

