import numpy
import os
#possible_bws = numpy.logspace(numpy.log(0.001), numpy.log(2), 100, base=numpy.e)
possible_bws = numpy.logspace(numpy.log(0.001), numpy.log(5), 300, base=numpy.e)


bws = [x for x in os.listdir('.') if 'bandwidth-' in x]

acc = []
for bf in bws:
	wbandwidth = int(bf[10:-4])
	fin = open(bf,'r')
	l = fin.next()
	gperf = numpy.asarray([float(x) for x in l.rstrip().split()])
	l = fin.next()
	bperf = numpy.asarray([float(x) for x in l.rstrip().split()])
	fin.close()
	acc.append((wbandwidth, gperf, bperf))

performances = numpy.zeros((possible_bws.shape[0],3))
for i,gperf,bperf in acc:
	performances[i,0] = numpy.mean(gperf) #float(numpy.where(gperf<0)[0].shape[0])/gperf.shape[0]
	performances[i,1] = numpy.mean(bperf) # float(numpy.where(bperf<0)[0].shape[0])/bperf.shape[0]
	#performances[i,2] = (numpy.mean(gperf)+numpy.mean(bperf))/2
	performances[i,2] = float(numpy.where(gperf<=0)[0].shape[0])/gperf.shape[0]+float(numpy.where(bperf<=0)[0].shape[0])/bperf.shape[0]

numpy.save('best-bandwidth.npy', possible_bws[numpy.argmin(performances[:,2])])
print 'bandwidth selected', possible_bws[numpy.argmin(performances[:,2])]