import numpy
import os

markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip()+'.bandwidth'
    markedbad.append(x)

markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip()+'.bandwidth'
    markedgood.append(x)

markedbad = set(markedbad)
markedgood = set(markedgood)

labeled = [x for x in os.listdir('bandwidths/') if 'bandwidth' in x]

acc = []
ngood = 0
nbad = 0
for f in labeled:
	facc = []
	ingood = f in markedgood
	if ingood:
		ngood += 1
	else:
		nbad += 1
	for line in open('bandwidths/'+f,'r'):
		vs = [float(x) for x in line.rstrip().split()]
		if ingood:
			facc.append([vs[0], vs[1], vs[2], 1])
		else:
			facc.append([vs[0], vs[1], vs[2], 0])
			
	#
	acc.append(numpy.asarray(facc))

ngood = float(ngood)
nbad = float(nbad)

cumacc = numpy.vstack(acc[1:])
bandwidths = numpy.unique(cumacc[:,0])
performances = numpy.zeros((bandwidths.shape[0],4))

pgood = cumacc[:,3]==1
pbad = cumacc[:,3]==0
for i in range(bandwidths.shape[0]):
	ppx = cumacc[:,0]==bandwidths[i]
	hgood = numpy.logical_and(ppx,pgood)
	hbad = numpy.logical_and(ppx,pbad)
	performances[i,0] = numpy.sum(cumacc[hgood,1]-cumacc[hgood,2]<=0)
	performances[i,1] = numpy.sum(cumacc[hbad,1]-cumacc[hbad,2]>0)
	performances[i,2] = numpy.median(cumacc[hgood,1]-cumacc[hgood,2])
	performances[i,3] = numpy.median(cumacc[hbad,1]-cumacc[hbad,2])


best_bandwidth = numpy.argmax((performances[:,0]+performances[:,1])/(ngood+nbad))

numpy.save('best-bandwidth.npy', bandwidths[best_bandwidth])
print 'bandwidth selected', bandwidths[numpy.argmax(performances[:,0])]

# bw = bandwidths[numpy.argmax(performances[:,0])]


# mispredicted_good = []
# mispredicted_bad = []
# correct_good = []
# correct_bad = []
# for ii,f in enumerate(labeled):
# 	if f in markedgood:
# 		if acc[ii][acc[ii][:,0]==bw,1]-acc[ii][acc[ii][:,0]==bw,2]>0:
# 			mispredicted_good.append(ii)
# 		else:
# 			correct_good.append(ii)
# 	else:
# 		if acc[ii][acc[ii][:,0]==bw,1]-acc[ii][acc[ii][:,0]==bw,2]<0:
# 			mispredicted_bad.append(ii)
# 		else:
# 			correct_bad.append(ii)

