import numpy
import sys
import os
import string
import random
import time

field_lookup = []
smpl_field_lookup = {}
i = 0
for line in open('sample/FULLDATA_field_info.txt'):
	l = line.rstrip().split('/')[-1]
	field_lookup.append(l)
	smpl_field_lookup[l] = i
	i += 1


rev_field_lookup = {}
exp_to_field = {}
z = numpy.load('sample/FULLDATA_exp_labels.npy')
for i in range(z.shape[0]):
    x = (numpy.mod(int(z[i,0])-1,48)+1, numpy.mod(int(z[i,1])-1,48)+1)
    if x not in exp_to_field:
        exp_to_field[x] = []
    exp_to_field[x].append(i)
    rev_field_lookup[i] = x


crazybad = []
for z in open('verybad.txt','r'):
    crazybad.append(z.rstrip().replace('.png',''))

crazybad = set(crazybad)

markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip().replace('.png','')
    markedbad.append(x)

markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip().replace('.png','')
    markedgood.append(x)

ignore_as_labeled = set(markedgood+markedbad)|crazybad

topatch = [x for x in os.listdir('markings/') if '.marking' in x]

perpatch = {}
perpatch_unlabeled = {}
for x in topatch:
	shortx = '.'.join(x.split('.')[:2])
	e = rev_field_lookup[smpl_field_lookup[shortx]]
	acc = []
	for line in open('markings/'+x,'r'):
		ss = line.rstrip().split()
		nn = ss[0].split('/')[-1]
		if nn not in crazybad:
			acc.append(( nn, float(ss[1])-float(ss[2]) ))
	if e not in perpatch:
		perpatch[e] = []
		perpatch_unlabeled[e] = []
	perpatch[e].extend(acc)
	perpatch_unlabeled[e].extend([(x,y) for (x,y) in acc if x not in ignore_as_labeled])

markings = [x for x in os.listdir('.') if '.marking' in x]
for m in markings:
	d,p = [int(z[1:]) for z in m.split('.')[0].split('-')]
	e = (d,p)
	acc = []
	for line in open(m,'r'):
		ss = line.rstrip().split()
		acc.append(( ss[0].split('/')[-1], float(ss[1])-float(ss[2]) ))
	if e not in perpatch:
		perpatch[e] = []
		perpatch_unlabeled[e] = []
	perpatch[e].extend(acc)
	perpatch_unlabeled[e].extend([(x,y) for (x,y) in acc if x not in ignore_as_labeled])

korder = perpatch.keys()


acc = []
unlabeled_images = []
unlabeled_data = []
for e in korder:
	a,b = zip(*perpatch[e])
	acc.append(numpy.asarray(b))
	if len(perpatch_unlabeled[e])>0:
		hunlabeled_images, hunlabeled_data = zip(*perpatch_unlabeled[e])
		unlabeled_images.extend(hunlabeled_images)
		unlabeled_data.extend(hunlabeled_data)


# lowdensity = []
# for e in korder:
# 	if len(perpatch_unlabeled[e]) > 0:
# 		if float(len(perpatch_unlabeled[e]))/len(perpatch[e]) > .9:
# 			lowdensity.append(e)

lcounts = []
for e in korder:
	lcounts.append(len(perpatch[e])-len(perpatch_unlabeled[e]))

fout = open('whatters.txt','w')
for e,l in zip(korder,lcounts):
	if l==1:
		fout.write(perpatch_unlabeled[e][0][0]+".png\n")

lowcounts = []
for e in korder:
	labele,crap = zip(*perpatch[e])
	if len(perpatch_unlabeled[e])>0:
		unlabele,crap = zip(*perpatch_unlabeled[e])
		labile = set(labele)-set(unlabele) # bad joke, sorry. I'm exhausted.
		sawgood = len([x for x in labile if x in markedgood])
		sawbad = len([x for x in labile if x in markedbad])
		if sawbad==0 or sawgood==0:
			lowcounts.append((e,sawgood, sawbad))

for e in [x[0] for x in lowcounts if x[1]==0]:
	fout.write(perpatch_unlabeled[e][0][0]+".png\n")	

fout.close()






zulu = []
for e in lowdensity:
	a,b = zip(*perpatch_unlabeled[e])
	zulu.append(numpy.median(b))

mediacc = [numpy.median(x) for x in acc]
pylab.boxplot([zulu, mediacc])
pylab.show()

bigmedians = [korder[x] for x in numpy.where(numpy.asarray(mediacc)>0)[0]]



fullacc = [item for sublist in acc for item in sublist]
# bestacc = numpy.asarray([numpy.min(x) for x in acc])
# worstacc = numpy.asarray([numpy.max(x) for x in acc])
# mediacc = [numpy.median(x) for x in acc]

# import pylab
# pylab.boxplot([fullacc, bestacc, worstacc, mediacc])
# pylab.show()


# map cutoffs to number of clones above it
crange = numpy.linspace(numpy.min(fullacc), 0.1,100)
cdata = numpy.zeros((crange.shape[0],2304))
fdata = numpy.zeros((crange.shape[0],2304))
for ci in range(crange.shape[0]):
	c = crange[ci]
	for i,a in enumerate(acc):
		cdata[ci,i] = numpy.sum(a>=c)
		fdata[ci,i] = float(cdata[ci,i])/a.shape[0]


maximum_threshold = crange[numpy.where(numpy.min(fdata,axis=1)==0)[0][0]]

unlabeled_data = numpy.asarray(unlabeled_data)
sidxn = numpy.argsort(unlabeled_data)
before_maximum_threshold_indices = sidxn[numpy.where(unlabeled_data[sidxn]<=maximum_threshold)[0]]

# grab an "even" sample of these images (say, 500)
stepsz = before_maximum_threshold_indices.shape[0]/500

examine = [unlabeled_images[x] for x in before_maximum_threshold_indices[::stepsz]]

for x in examine:
	os.system('ln -s image_cache/'+x+'.png')

valgoods = []
for line in open('valgood.txt'):
	valgoods.append(line.rstrip().replace('.png',''))

valbads = []
for line in open('valbad.txt'):
	valbads.append(line.rstrip().replace('.png',''))

dgoods = []
for v in valgoods:
	dgoods.append(unlabeled_data[unlabeled_images.index(v)])

dbads = []
for v in valbads:
	dbads.append(unlabeled_data[unlabeled_images.index(v)])


sweeper = numpy.hstack([dgoods,dbads])
sweeper = numpy.sort(sweeper)
dgoods = numpy.asarray(dgoods)
dbads = numpy.asarray(dbads)

precision = numpy.zeros(sweeper.shape[0])
recall = numpy.zeros(sweeper.shape[0])
fpr = numpy.zeros(sweeper.shape[0])
accuracy = numpy.zeros(sweeper.shape[0])
for ii in range(sweeper.shape[0]):
	tp = numpy.sum(dgoods<=sweeper[ii])
	fp = numpy.sum(dbads<=sweeper[ii])
	tn = numpy.sum(dbads>sweeper[ii])
	precision[ii] = float(tp)/(tp+fp)
	recall[ii] = float(tp)/dgoods.shape[0]
	fpr[ii] = float(fp)/dbads.shape[0]
	accuracy[ii] = float(tp+tn)/(dgoods.shape[0]+dbads.shape[0])


import time
today = time.strftime("%m%d%y")

pylab.plot(recall, precision, 'k.-')
pylab.xlabel('recall')
pylab.ylabel('precision')
pylab.axis([0,1,0,1])
pylab.savefig(today+'runx_precision_recall.png', bbox='tight')
pylab.show()

from scipy.integrate import trapz
auc = trapz(numpy.hstack([0,recall]), x=numpy.hstack([0,fpr]))

pylab.plot(numpy.hstack([0,fpr]), numpy.hstack([0,recall]), 'k.-')
pylab.plot([0,1],[0,1], 'r:')
pylab.xlabel('fpr')
pylab.ylabel('tpr')
pylab.title('AUC='+str(auc))
pylab.axis([0,1,0,1])
pylab.savefig(today+'runx_roc.png', bbox='tight')
pylab.show()
