#!/opt/python27/bin/python
import numpy
import sys
import os
import string
import random
import itertools

os.chdir('/home/twoactive/filtering')

def kdist(bw,axs,ays):
    if ays.shape[0] < axs.shape[0]:
        ys = axs
        xs = ays
    else:
        ys = ays
        xs = axs        
    acc = 0.0
    inv_sq_bw = -0.5/bw**2
    dd = numpy.zeros(ys.shape)
    for i in range(xs.shape[0]):
        dd[:] = ys[:]
        dd -= xs[i,:]
        acc += numpy.sum(numpy.exp(inv_sq_bw*numpy.sum(dd**2,axis=1)))
    return acc/(xs.shape[0]*ys.shape[0])

def fullmmdl(bw,xs,ys):
    return kdist(bw,xs,xs)+kdist(bw,ys,ys)-2.0*kdist(bw,xs,ys)



def mmdl(bw,xs,ys):
    z = rawmmdl(bw,xs,ys)
    return z


markedbad = []
for f in open('baddies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedbad.append(x)

markedgood = []
for f in open('goodies.txt','r'):
    x = f.rstrip().replace('.png', '.npy')
    markedgood.append(x)

markedbad = list(set(markedbad))
markedgood = list(set(markedgood))

probablywtf = set(markedgood) & set(markedbad)

print 'probablywtf should be empty', probablywtf

whoami = markedgood[0][:-4] #os.environ['WINSTANCE']

matchname = 'filter/surfcache/'+whoami[:-4]+'.npy'

datagood = []
for x in markedgood:
    if ( x not in probablywtf ) and ( x != matchname ):
        if not os.path.exists('/scratch/'+x):
            if os.path.exists('filter/surfcache/'+x):
                print 'copying'
                os.system('cp filter/surfcache/'+x+' /scratch/'+x)
            else:
                continue
        datagood.append(numpy.load('/scratch/'+x))


databad = []
for x in markedbad:
    if ( x not in probablywtf ) and ( x != matchname ):
        if not os.path.exists('/scratch/'+x):
            if os.path.exists('filter/surfcache/'+x):
                print 'copying'
                os.system('cp filter/surfcache/'+x+' /scratch/'+x)
            else:
                continue
        databad.append(numpy.load('/scratch/'+x))

databad = [x for x in databad if x.shape[0] > 5]

rname = whoami+'.npy'
surfname = 'filter/surfcache/'+rname
if not os.path.exists('/scratch/'+rname):
    if os.path.exists(surfname):
        os.system('cp '+surfname+' /scratch/'+rname)


field_data_green = numpy.load('/scratch/'+rname)


me_to_myself = kdist(bw,field_data_green,field_data_green)

def myfullmmdl(bw,ys):
    return me_to_myself+kdist(bw,ys,ys)-2.0*kdist(bw,field_data_green,ys)

def mymmdl(bw,xs,ys):
    if ys.shape[0]>32:
        return rawmmdl(bw,xs,ys)
    else:
        return myfullmmdl(bw,ys)

possible_bws = numpy.logspace(numpy.log(0.01), numpy.log(3), 100, base=numpy.e)

import time
gacc = numpy.zeros((len(datagood),))
startt = time.time()
for ii in range(len(datagood)):
    print ii
    numpy.random.shuffle(datagood[ii])
    gacc[ii] = mymmdl(bw, field_data_green, datagood[ii])

endtt = time.time()

print endtt-startt


bacc = numpy.zeros((len(databad),))
startt = time.time()
for ii in range(len(databad)):
    print ii
    bacc[ii] = mymmdl(bw, field_data_green, databad[ii])

endtt = time.time()

print endtt-startt



diffs = numpy.asarray(acc)-numpy.asarray(bacc)
sizes = numpy.asarray([datagood[x].shape[0] for x in range(len(acc))])


startt = time.time()
kdist(bw,field_data_green,field_data_green)
endtt = time.time()
print endtt-startt





numpy.random.shuffle(datagood[5])
mmdl(bw, field_data_green, datagood[5])
fullmmdl(bw, field_data_green, datagood[5])

bw = possible_bws[10]
gd = [mmdl(bw, field_data_green, x) for x in datagood]
bd = [mmdl(bw, field_data_green, x) for x in databad]
gdm = numpy.nanmin(gd)
bdm = numpy.nanmin(bd)
delta = gdm-bdm




if not os.path.exists('bandwidths/'+whoami+'.bandwidth'):
    fout = open('bandwidths/'+whoami+'.bandwidth','w')
    for bw in possible_bws:
        print bw
        if field_data_green.shape[0] > 0:
            gd = [mmdl(bw, field_data_green, x) for x in datagood]
            bd = [mmdl(bw, field_data_green, x) for x in databad]
            gdm = numpy.nanmin(gd)
            bdm = numpy.nanmin(bd)
            delta = gdm-bdm
            fout.write(str(bw)+' '+str(gdm)+' '+str(bdm)+"\n")

fout.close()

