import numpy
import sys
import os
import string
import scipy.stats
import random
import ic100
import scipy
import scipy.misc
import scipy.ndimage
import itertools

thedata = numpy.load('zscored_data_posthoc.npy')
theindices = numpy.load('indices_posthoc.npy')

print 'building exp_to_range'
exp_to_range = {}
for i in range(theindices.shape[0]):
    if (theindices[i,0], theindices[i,1]) not in exp_to_range:
        exp_to_range[(theindices[i,0], theindices[i,1])] = []
    exp_to_range[(theindices[i,0], theindices[i,1])].append(i)

for i in exp_to_range.keys():
    j = exp_to_range[i]
    exp_to_range[i] = (numpy.min(j), numpy.max(j)+1)

field_lookup = []
smpl_field_lookup = []
for line in open('posthoc_field_order.txt'):
    field_lookup.append(line.rstrip())
    smpl_field_lookup.append(string.split(field_lookup[-1],'/')[-1])

rev_field_lookup = {}
exp_to_field = {}
#z = numpy.load('sample/FULLDATA_exp_labels.npy')
for i in range(theindices.shape[0]):
    x = (int(theindices[i,0]), int(theindices[i,1]))
    if x not in exp_to_field:
        exp_to_field[x] = []
    exp_to_field[x].append(i)
    rev_field_lookup[i] = x


exp_order = [(x,y) for (x,y) in exp_to_range.keys() if y < 97]
ignore_exps = [(x,y) for (x,y) in exp_to_range.keys() if y > 96]
ignore_positions = [item for sublist in [range(exp_to_range[x][0],exp_to_range[x][1]) for x in ignore_exps] for item in sublist]

linkages = {}
lorder = {}
for i,e in enumerate(exp_order):
    lorder[e] = i

for i in range(1,49):
    for j in range(1,49):
        linkages[i,j] = []
        for ii in [0,48]:
            for jj in [0,48]:
                if (i+ii,j+jj) in exp_to_range:
                    linkages[i,j].append((i+ii,j+jj))

# ranges_of_48 = {}
# for re, xs in linkages.iteritems():
#     ranges_of_48[re] = []
#     for e in xs:
#         ranges_of_48[re].extend(range(exp_to_range[e][0],exp_to_range[e][1]))

ranges_of_48 = {}
for i in range(theindices.shape[0]):
    e = ( theindices[i,0]-1 ) % 48 + 1, ( theindices[i,1]-1 ) % 48 + 1
    if e not in ranges_of_48:
        ranges_of_48[e] = []
    ranges_of_48[e].append(i)

summary48 = numpy.zeros((48*48,thedata.shape[1]))
linkorder = [x for x in itertools.product(range(1,49),range(1,49))]
for i,e in enumerate(linkorder):
    summary48[i,:] = numpy.median(thedata[ranges_of_48[e],:],axis=0)


print 'rank exemplars'
ranked_for_each_exp48 = {}
for e,xs in exp_to_range.iteritems():
    if e in exp_to_field:
        x = (e[0]-1)%48+1, (e[1]-1)%48+1
        if x not in ranked_for_each_exp48:
            ranked_for_each_exp48[x] = ([],[])
        centroid = summary48[linkorder.index(x),:]
        for f in exp_to_field[e]:
            ranked_for_each_exp48[x][0].append(f)
            ranked_for_each_exp48[x][1].append(numpy.linalg.norm(thedata[f,:]-centroid,2))

order_for_each_exp48 = {}
for x in ranked_for_each_exp48.keys():
    v = numpy.argsort(ranked_for_each_exp48[x][1])
    order_for_each_exp48[x] = [ranked_for_each_exp48[x][0][z] for z in v]

CACHED_IMAGES = os.listdir('image_cache')

print 'working on unperturbeds'
unperturbeds = []
for p in range(1,49):
    outimg = numpy.zeros((1024,1344,3), dtype='uint16')
    e = 48,p
    fi = order_for_each_exp48[e][0]
    f = field_lookup[fi]
    broken = string.split(f,'/')
    if broken[-1]+'.png' not in CACHED_IMAGES:
    # if True:
        print '**** fetching image'
        bluename = '/lane/'+f
        outimg[:,:,2] = ic100.read_ic100_BMP(bluename)
        outimg[:,:,1] = ic100.read_ic100_BMP(bluename.replace('ch_00', 'ch_01'))
        for i in range(1,3):
            outimg[:,:,i] -= numpy.min(outimg[:,:,i])
            outimg[:,:,i] *= 4095.0/float(numpy.max(outimg[:,:,i]))
        scipy.misc.imsave('image_cache/'+broken[-1]+'.png', outimg)
    else:
        outimg = scipy.misc.imread('image_cache/'+broken[-1]+'.png')
    unperturbeds.append(outimg)        



outimg = numpy.zeros((1024,1344,3), dtype='uint16')
foutimg = numpy.zeros((1024,1344*2,3), dtype='uint16')

wowser_responsive_experiments = numpy.loadtxt('wowser_responsive_experiments.csv',dtype='int')
jjj = 0
for dd,pp,dc,pc,rr in wowser_responsive_experiments:
    print dd,pp,dc,pc,rr
    d = dd+1
    p = pp+1
    jjj += 1
    e = (d,p)
    fi = order_for_each_exp48[e][0]
    f = field_lookup[fi]
    broken = string.split(f,'/')
    if broken[-1]+'.png' not in CACHED_IMAGES:
    # if True:
        print '**** fetching image'
        bluename = f
        outimg[:,:,2] = ic100.read_ic100_BMP(bluename) 
        outimg[:,:,1] = ic100.read_ic100_BMP(bluename.replace('ch_00', 'ch_01'))
        for i in range(1,3):
            outimg[:,:,i] -= numpy.min(outimg[:,:,i])
            outimg[:,:,i] *= 4095.0/float(numpy.max(outimg[:,:,i]))
        scipy.misc.imsave('image_cache/'+broken[-1]+'.png', outimg)
    else:
        outimg = scipy.misc.imread('image_cache/'+broken[-1]+'.png')
    foutimg[:,:1344,:] = unperturbeds[pp]
    foutimg[:,1344:,:] = outimg
    scipy.misc.imsave('posthoc_results/responders/rank'+str(jjj).zfill(4)+'-d'+str(d).zfill(2)+'-p'+str(p).zfill(2)+'-'+'dc'+str(dc)+'-pc'+str(pc)+'-effect'+str(rr).zfill(4)+'.png', foutimg)




# print 'grab example good/bad snapshots'
# goods = os.listdir('image_examples/good')
# bads = os.listdir('image_examples/bad')
# # terribles = os.listdir('image_examples/completelybad')
# # terribles = random.sample(terribles,len(terribles)/2)
# terribles = []


# points_per = 20
# trained_data = numpy.zeros((points_per*(len(goods)+len(bads)+len(terribles)),128), dtype='float32')
# values = numpy.zeros((trained_data.shape[0],), dtype='float32')
# i = 0
# for g in goods:
#     z = cv2.imread('image_examples/good/'+g)
#     imgg = cv2.cvtColor(z,cv2.COLOR_BGR2GRAY)
#     surf = cv2.SURF()
#     kp, desc = surf.detect(imgg,None,useProvidedKeypoints = False)
#     if len(desc)>0:
#         desc = numpy.reshape(desc,(desc.shape[0]/128,128))
#         taking = min(points_per,desc.shape[0])
#         trained_data[i:(i+taking),:] = desc[:taking,:]
#         i += taking

# values[:i] = 1
# oldi = i
# for g in bads:
#     z = cv2.imread('image_examples/bad/'+g)
#     imgg = cv2.cvtColor(z,cv2.COLOR_BGR2GRAY)
#     surf = cv2.SURF()
#     kp, desc = surf.detect(imgg,None,useProvidedKeypoints = False)
#     if len(desc)>0:
#         desc = numpy.reshape(desc,(desc.shape[0]/128,128))
#         taking = min(points_per,desc.shape[0])
#         trained_data[i:(i+taking),:] = desc[:taking,:]
#         i += taking

# values[oldi:i] = 0
# oldi = i

# # for g in terribles:
# #     z = cv2.imread('image_examples/completelybad/'+g)
# #     imgg = cv2.cvtColor(z,cv2.COLOR_BGR2GRAY)
# #     surf = cv2.SURF()
# #     kp, desc = surf.detect(imgg,None,useProvidedKeypoints = False)
# #     if len(desc)>0:
# #         desc = numpy.reshape(desc,(desc.shape[0]/128,128))
# #         taking = min(points_per,desc.shape[0])
# #         trained_data[i:(i+taking),:] = desc[:taking,:]
# #         i += taking

# # values[oldi:i] = 2


# print 'howmany', i

# print 'training...'
# forest = cv2.RTrees()
# forest.train(trained_data[:i,:], cv2.CV_ROW_SAMPLE, values[:i], params=dict([('max_num_of_trees_in_the_forest',1113), ('nactive_vars', 3), ('termcrit_type', cv2.cv.CV_TERMCRIT_ITER)]))

# print 'finding greatest spread of data'
# Y = scipy.spatial.distance.squareform(scipy.spatial.distance.pdist(summary48))
# Y = numpy.max(Y) - Y
# import heapq
# touched = set([])
# untouched = set(range(len(linkorder)))
# # this is for the case where we're keeping goods
# for g in goods:
#     if 'line' not in g:
#         blah = string.split(g[3:],'-')[0]
#         if blah in smpl_field_lookup:
#             meow = rev_field_lookup[smpl_field_lookup.index(blah)]
#             touched.add(linkorder.index(((meow[0]-1)%48+1,(meow[1]-1)%48+1)))


# print 'already assigned to', len(touched), len(linkorder)
# untouched -= touched
# myheap = []
# for t in touched:
#     for u in untouched:
#         myheap.append((Y[t,u],(t,u)))

# heapq.heapify(myheap)

# working_set = []
# for round in range(48*48-len(touched)):
#     grab = heapq.heappop(myheap)
#     while ( grab[1][0] in touched ) and ( grab[1][1] in touched ):
#         grab = heapq.heappop(myheap)
#     if ( grab[1][0] in touched ):
#         addme = grab[1][1]
#     else:
#         addme = grab[1][0]
#     untouched.remove(addme)
#     touched.add(addme)
#     for u in untouched:
#         heapq.heappush(myheap,(Y[addme,u],(addme,u)))
#     working_set.append(linkorder[addme])

# print 'working on', len(working_set)

# #working_set = [linkorder[x] for x in numpy.where(touched)[0]]
# #working_set = linkorder

# CACHED_IMAGES = os.listdir('image_cache')
# snap = numpy.zeros((300,300,3), dtype='uint16')
# snap2 = numpy.zeros((300,300,3), dtype='uint8')
# outimg = numpy.zeros((1024,1344,3), dtype='uint16')
# touched = numpy.zeros(outimg.shape, dtype=numpy.bool)

# FORCE_DUMP = False

# for shakazulu, e in enumerate(working_set):
#     print 'testing...', shakazulu, len(working_set)
#     found_example = False
#     for zulu, fi in enumerate(order_for_each_exp48[e]):
#         # if zulu > 2:
#         #     break
#         print '...working on field', zulu, len(order_for_each_exp48[e]), e
#         f = field_lookup[fi]
#         broken = string.split(f,'/')
#         if broken[-1]+'.png' not in CACHED_IMAGES:
#         # if True:
#             print '**** fetching image'
#             bluename = '/lane'+f
#             outimg[:,:,2] = ic100.read_ic100_BMP(bluename)
#             outimg[:,:,1] = ic100.read_ic100_BMP(bluename.replace('ch_00', 'ch_01'))
#             for i in range(1,3):
#                 outimg[:,:,i] -= numpy.min(outimg[:,:,i])
#                 outimg[:,:,i] *= 4095.0/float(numpy.max(outimg[:,:,i]))
#             scipy.misc.imsave('image_cache/'+broken[-1]+'.png', outimg)
#         else:
#             outimg = scipy.misc.imread('image_cache/'+broken[-1]+'.png')
#         if len(outimg.shape)==0:
#             # some files got corrupted in the transfer from the server?  fix on the next pass
#             print 'blowing away ', 'image_cache/'+broken[-1]+'.png'
#             os.remove('image_cache/'+broken[-1]+'.png')
#             break
#         blurred_blue = scipy.ndimage.gaussian_filter(outimg[:,:,2], sigma=10)
#         peaks = skimage.feature.peak_local_max(blurred_blue,min_distance=10)
#         snap[:] = 0
#         touched[:] = False
#         for i in range(peaks.shape[0]):
#             minx = peaks[i,0]-150
#             maxx = peaks[i,0]+150
#             miny = peaks[i,1]-150
#             maxy = peaks[i,1]+150
#             # if ( minx < 0 ) or ( maxx > 1024 ) or ( miny < 0 ) or ( maxy > 1344 ):
#             #     break
#             if minx < 0:
#                 maxx += 0-minx
#                 minx += 0-minx
#             if maxx > 1024:
#                 minx += 1024-maxx
#                 maxx += 1024-maxx
#             if miny < 0:
#                 maxy += 0-miny
#                 miny += 0-miny
#             if maxy > 1344:
#                 miny += 1344-maxy
#                 maxy += 1344-maxy
#             if not numpy.any(touched[minx:maxx,miny:maxy,:]):
#                 touched[minx:maxx,miny:maxy,:] = True
#                 snap[:,:,:] = outimg[minx:maxx,miny:maxy,:]
#                 snap2[:] = snap
#                 if FORCE_DUMP:
#                     scipy.misc.imsave('image_examples/bucket/'+broken[-1]+'--'+str(i)+'.png', snap)
#                     found_example = True
#                 else:
#                     imgg = cv2.cvtColor(snap2,cv2.COLOR_BGR2GRAY)
#                     surf = cv2.SURF()
#                     kp, desc = surf.detect(imgg,None,useProvidedKeypoints = False)
#                     # kp, desc_green = surf.detect(snap2[:,:,1].copy(),None,useProvidedKeypoints = False)
#                     if len(desc)>0:
#                         desc = numpy.reshape(desc,(desc.shape[0]/128,128))
#                         ppp = 0
#                         baddie = 0
#                         count = min(points_per, desc.shape[0])
#                         for k in range(count):
#                             if forest.predict(desc[k,:])==1.0:
#                                 ppp += 1.0
#                             elif forest.predict(desc[k,:])==2.0:
#                                 baddie += 1
#                         ppp /= count
#                         myname = str(int(100*ppp)).zfill(3)+broken[-1]+'--'+str(i)+'--'+str(e[0])+'-'+str(e[1])+'.png'
#                         if ppp > 0.5:
#                             print ppp, baddie
#                             scipy.misc.imsave('image_examples/pred_good/'+myname, snap)
#                             found_example = True
#                         elif baddie == count:
#                             print 'blowing away ', 'image_cache/'+broken[-1]+'.png'
#                             try:
#                                 os.remove('image_cache/'+broken[-1]+'.png')
#                             except:
#                                 pass
#                         else:
#                             # print ppp, baddie
#                             # myname = '111'+broken[-1]+'--'+str(i)+'--'+str(e[0])+'-'+str(e[1])+'.png'
#                             scipy.misc.imsave('image_examples/pred_bad/'+myname, snap)                            
#         if found_example:
#             break
#     if not found_example:
#         print '********** SHIT ', e
#         fout = open('stupid-no-good-images-of.csv','a+')
#         for fi in order_for_each_exp48[e]:
#             f = field_lookup[fi]
#             broken = string.split(f,'/')
#             # print 'blowing away ', 'image_cache/'+broken[-1]+'.png'
#             # try:
#             #     os.remove('image_cache/'+broken[-1]+'.png')
#             # except:
#             #     pass
#             fout.write(str(e[0])+' '+str(e[1])+' '+'image_cache/'+broken[-1]+'.png'+"\n")
#         fout.close()

