import numpy
import sys
import os
import string
import scipy.stats
import itertools


def maxcount(arr):
    return numpy.argmax(numpy.bincount(arr))

thedata = numpy.load('calculated/zscored_data.npy')
theindices = numpy.load('calculated/indices.npy')

print 'building exp_to_range'
exp_to_range = {}
for i in range(theindices.shape[0]):
    if (theindices[i,0], theindices[i,1]) not in exp_to_range:
        exp_to_range[(theindices[i,0], theindices[i,1])] = []
    exp_to_range[(theindices[i,0], theindices[i,1])].append(i)

for i in exp_to_range.keys():
    j = exp_to_range[i]
    exp_to_range[i] = (numpy.min(j), numpy.max(j)+1)


def per_round_workload(which_round):
    ap = open('sample/bear_round'+str(which_round)+'.apredictions','r')
    observed_experiments = []
    frontier_experiments = []
    exp_to_pheno = {}
    pheno_to_predicted = {}
    pheno_to_obs_exps = {}
    phenos = set([])
    predicted_experiments = []
    for rline in ap:
        Line = string.split(rline.rstrip())
        place = (int(Line[0]), int(Line[1]))
        if '1' in Line[4]:
            observed_experiments.append(place)
            if int(Line[2]) not in pheno_to_obs_exps:
                pheno_to_obs_exps[int(Line[2])] = []
            pheno_to_obs_exps[int(Line[2])].append(place)
        else:
            if int(Line[2]) not in pheno_to_predicted:
                pheno_to_predicted[int(Line[2])] = []
            pheno_to_predicted[int(Line[2])].append(place)
            if place in exp_to_range:
                predicted_experiments.append(place)
        if '1' in Line[5]:
            frontier_experiments.append(place)
        exp_to_pheno[place] = int(Line[2])
        phenos.add(int(Line[2]))
    #
    phenos = list(phenos)
    phenos_array = numpy.asarray(phenos)
    badphenos = []
    #
    extra_experiments = [x for x in itertools.product(range(1,49), [101, 102, 103, 104, 105, 107])]
    extra_distances = numpy.zeros((sum([a[1] - a[0] for a in [exp_to_range[x] for x in extra_experiments]]), len(phenos)))
    extra_indices = numpy.zeros((len(extra_experiments),2), dtype='i2')
    i = 0
    for j,e in enumerate(extra_experiments):
        extra_indices[j,0] = i
        i += exp_to_range[e][1] - exp_to_range[e][0]
        extra_indices[j,1] = i
    #
    for k,ph in enumerate(phenos):
        j = 0
        print "in phenotype", ph, 'round', which_round
        myname = 'calculated/COMPUTED-round-'+str(which_round)+'-ph-'+str(ph)+'.npy'
        ph_data = numpy.load(myname)
        if ph_data.shape[0] > 0:
            against = numpy.zeros(ph_data.shape)
            for e in extra_experiments:
                for f in range(exp_to_range[e][0], exp_to_range[e][1]):
                    against = ph_data - thedata[f,:]
                    extra_distances[j,k] = numpy.min(numpy.sum(against**2,axis=1))
                    j += 1
        else:
            extra_distances[:,k] = numpy.infty
    #
    extra_mindists = numpy.argmin(extra_distances,axis=1)
    extra_votes = numpy.zeros((len(extra_experiments),), dtype='i2')
    for i in range(extra_votes.shape[0]):
        extra_votes[i] = phenos[maxcount(extra_mindists[extra_indices[i,0]:extra_indices[i,1]])]
    #
    fout = open('calculated/POSTHOC-round-'+str(which_round)+'-extraphenotypes.txt','w')
    for i in range(extra_votes.shape[0]):
        fout.write(' '.join([str(x) for x in [extra_experiments[i][0], extra_experiments[i][1], extra_votes[i]]])+"\n")
    #
    fout.close()



per_round_workload(30)