import numpy
import string
import os
import sys
import itertools

batch_size = 16 # int(sys.argv[2])

# first, build the complete data
whichround = int(sys.argv[1])

myline_lookup = {}
myline_lookup[101] = 97
myline_lookup[102] = 98
myline_lookup[103] = 99
myline_lookup[104] = 100
myline_lookup[105] = 101
myline_lookup[107] = 102
for i in range(1,97):
    myline_lookup[i] = i


inner_observed = []
fulldata = {}
observed = []
fout = open('/home/active/special/looking_for_the_two/round'+str(whichround)+'/extra_posthoc_phenotypes.txt','w')
for line in open('/home/active/special/sample/round'+str(whichround)+'_phenotypes.txt','r'):
    Line = string.split(line.rstrip())
    g = int(Line[0])
    oi = myline_lookup[int(Line[1])]
    ph = int(Line[2])
    fout.write(str(g)+' '+str(oi)+' '+str(ph)+"\n")
    fulldata[g,oi] = ph
    observed.append((g,oi))
    inner_observed.append((g,oi))

for line in open('/home/active/special/POSTHOC-round-'+str(whichround)+'-extraphenotypes.txt','r'):
    Line = string.split(line.rstrip())
    g = int(Line[0])
    oi = myline_lookup[int(Line[1])]
    ph = int(Line[2])
    fout.write(str(g)+' '+str(oi)+' '+str(ph)+"\n")
    fulldata[g,oi] = ph
    if (g == 48):
        observed.append((g,oi))

if whichround == 2:
    # we were missing lines, just add in fake data to keep the AL happy
    fulldata[(48,42)] = 9999999
    fulldata[(48,43)] = 99999999
    fulldata[(48,90)] = 999999999
    fulldata[(48,91)] = 9999999999
    observed.extend([(48,42), (48,43), (48,90), (48,91)])
    inner_observed.extend([(48,42), (48,43), (48,90), (48,91)])
    fout.write("48 42 9999999\n")
    fout.write("48 43 99999999\n")
    fout.write("48 90 999999999\n")
    fout.write("48 91 9999999999\n")

fout.close()

# form the excluded set
fout = open('/home/active/special/looking_for_the_two/round'+str(whichround)+'/excluded_subset.txt','w')
for x,y in [(x,y) for x,y in itertools.product(range(1,97), range(1,97)) if (x,y) not in inner_observed]:
    fout.write(str(x)+' '+str(y)+'\n')

for x,y in itertools.product(range(49,97), range(97,103)):
    fout.write(str(x)+' '+str(y)+'\n')

fout.close()

# now iterate through
accuracies = []
for vv in range(47*6/batch_size):
    fout = open('/home/active/special/looking_for_the_two/round'+str(whichround)+'/EXTRAPOSTHOC.txt','w')
    for x,y in observed:
        fout.write(str(x)+' '+str(y)+' '+str(fulldata[x,y])+"\n")
    fout.close()
    os.system('forte -noX -f PER_ROUND_EXTRA_SIMULATION.fl')
    # grab the predictions
    correct = 0
    for line in open('/home/active/special/looking_for_the_two/round'+str(whichround)+'/EXTRATITLE.apredictions','r'):
        Line = string.split(line.rstrip())
        g = int(Line[0])
        oi = int(Line[1])
        ph = int(Line[2])
        if ( oi > 96 ) and ((g,oi) in fulldata):
            if ph == fulldata[g,oi]:
                correct += 1
    #
    accuracies.append(correct)
    # now grab the frontier and add it in
    for line in open('/home/active/special/looking_for_the_two/round'+str(whichround)+'/EXTRATITLE.frontier','r'):
        Line = string.split(line.rstrip())
        g = int(Line[0])
        oi = int(Line[1])
        observed.append((g,oi))

numpy.savetxt('/home/active/special/REPORT-extra-simulations-round'+str(whichround)+'.csv',accuracies, fmt='%d', newline=' ')