import numpy
import string
import pylab

import numpy
import sys
import os
import string
import scipy.stats
import scipy.spatial.distance

# lifted from Luis's code in order to not import mahotas and all the rest of that elephant
def linearly_independent_subset(V, threshold=1.e-5, return_orthogonal_basis=False):
	V = numpy.array(V, copy=True)
	orthogonal = []
	used = []
	for i,u in enumerate(V):
		for v in orthogonal:
			u -= numpy.dot(u,v)/numpy.dot(v,v) * v
		if numpy.dot(u,u) > threshold:
			orthogonal.append(u)
			used.append(i)
	if return_orthogonal_basis:
		return numpy.array(used),numpy.array(orthogonal)
	return numpy.array(used)

if not os.path.exists('calculated/again-thedata.npy'):
	print 'building rawdata'
	badfeats = set([])
	for rline in open('data/bad_images.csv','r'):
		Line = string.split(rline.rstrip(), '/')
		badfeats.add(Line[-1])
	#
	well_to_experiment = {}
	for z in os.listdir('data'):
		if 'WELLMAP' in z:
			partnames = string.split(z[:-4], '-')
			thename = partnames[1]
			f = open('data/'+z,'r')
			next(f)
			for rline in f:
				Line = string.split(rline.rstrip())
				well_to_experiment[(thename, Line[0], int(Line[1]))] = (int(Line[4]), int(Line[2]))
	#
	experiment_to_fields = {}
	for z in os.listdir('justfeats'):
		Line = [x for x in string.split(z,'_') if len(x)>0]
		if z not in badfeats:
			if 'batch' in Line[0]:
				thename = 'round'+Line[0][5:]
			else:
				thename = Line[0]
			place = well_to_experiment[(thename, Line[1], int(Line[2]))]
			if place not in experiment_to_fields:
				experiment_to_fields[place] = []
			experiment_to_fields[place].append('justfeats/'+z)
	#
	thedata = numpy.zeros((numpy.sum([len(x) for x in experiment_to_fields.values()]), 173))
	theindices = numpy.zeros((thedata.shape[0],2), dtype='i2')
	i = 0
	thefieldorder = []
	for e,l in experiment_to_fields.iteritems():
		for f in l:
			theindices[i,0] = e[0]
			theindices[i,1] = e[1]
			thedata[i,:] = numpy.load(f)
			thefieldorder.append(f)
			i += 1
	#
	mean_of_thedata = numpy.mean(thedata,axis=0)
	thedata -= mean_of_thedata
	std_of_thedata = numpy.std(thedata,axis=0)
	thedata /= std_of_thedata
	thedata = thedata[:,numpy.where(numpy.logical_not(numpy.isnan(numpy.std(thedata,axis=0))))[0]]
	goodfeats = linearly_independent_subset(thedata.T)
	thedata = thedata[:,goodfeats]
	numpy.save('calculated/again-thedata.npy', thedata)
	numpy.save('calculated/again-theindices.npy', theindices)
	fout = open('calculated/again-thefieldorder.txt','w')
	for x in thefieldorder:
		fout.write(x+"\n")
	#
	fout.close()


thedata = numpy.load('calculated/again-thedata.npy')
theindices = numpy.load('calculated/again-theindices.npy')
thefields = []
for x in open('calculated/again-thefieldorder.txt'):
	thefields.append(x.rstrip())

print 'building exp_to_range'
exp_to_range = {}
for i in range(theindices.shape[0]):
	if (theindices[i,0], theindices[i,1]) not in exp_to_range:
		exp_to_range[(theindices[i,0], theindices[i,1])] = []
	exp_to_range[(theindices[i,0], theindices[i,1])].append(i)

for i in exp_to_range.keys():
	j = exp_to_range[i]
	exp_to_range[i] = (numpy.min(j), numpy.max(j)+1)

which_round = 30

ap = open('sample/bear_round'+str(which_round)+'.apredictions','r')
observed_experiments = []
frontier_experiments = []
exp_to_pheno = {}
pheno_to_predicted = {}
pheno_to_obs_exps = {}
phenos = set([])
predicted_experiments = []
for rline in ap:
	Line = string.split(rline.rstrip())
	place = (int(Line[0]), int(Line[1]))
	if '1' in Line[4]:
		observed_experiments.append(place)
		if int(Line[2]) not in pheno_to_obs_exps:
			pheno_to_obs_exps[int(Line[2])] = []
		pheno_to_obs_exps[int(Line[2])].append(place)
	else:
		if int(Line[2]) not in pheno_to_predicted:
			pheno_to_predicted[int(Line[2])] = []
		pheno_to_predicted[int(Line[2])].append(place)
		if place in exp_to_range:
			predicted_experiments.append(place)
	if '1' in Line[5]:
		frontier_experiments.append(place)
	exp_to_pheno[place] = int(Line[2])
	phenos.add(int(Line[2]))


pheno_indexing = { ph : ii  for (ii,ph) in enumerate(sorted(phenos)) }
mphenos = numpy.zeros((thedata.shape[0],),dtype='int')
mphenos[:] = -1
for ph in phenos:
	for e in pheno_to_obs_exps[ph]:
		if e in exp_to_range:
			mphenos[exp_to_range[e][0]:exp_to_range[e][1]] = pheno_indexing[ph]

observed_idxn = mphenos!=-1

mdata = thedata[observed_idxn,:]
mindices = theindices[observed_idxn,:]
mphenos = mphenos[observed_idxn]
mfields = [thefields[x].split('/')[1][:-4]+'.png' for x in numpy.where(observed_idxn)[0]]

from sklearn.linear_model import LogisticRegressionCV
from sklearn.externals import joblib

if not os.path.exists('lr-all-cv.pkl'):
	LR = LogisticRegressionCV(n_jobs=-1, cv=10, verbose=1, solver='sag')
	LR.fit(mdata, mphenos)
	joblib.dump(LR, 'lr-all-cv.pkl')
else:
	LR = joblib.load('lr-all-cv.pkl') 

print 'accuracy', LR.score(mdata, mphenos)


# for each class, which is best predicted? and which is worst?
P = LR.predict_proba(mdata)

preds = LR.predict(mdata)
from sklearn.metrics import confusion_matrix, adjusted_rand_score
# C = confusion_matrix(mphenos, preds)

# nucleoli = [5, 12, 19, 36, 39]

human_labels = []
for line in open('metadata/clone_assignments.txt'):
	human_labels.append(line.rstrip())

human_phenos_lookup = { x : ii for (ii,x) in enumerate(set(human_labels))}
human_clone_phenos = [human_phenos_lookup[x] for x in human_labels]

unperturbed = numpy.logical_or(mindices[:,0]==48, mindices[:,0]==96)

hcphenos = numpy.array([human_clone_phenos[z] for z in (mindices[unperturbed,1]-1) % 48])
if not os.path.exists('lrh-all.pkl'):
	LRh = LogisticRegression()
	LRh.fit(mdata[unperturbed], hcphenos)
	joblib.dump(LRh, 'lrh-all.pkl')
else:
	LRh = joblib.load('lrh-all.pkl') 

LRh.score(mdata[unperturbed], hcphenos)
hcpreds = LRh.predict(mdata)
# adjusted_rand_score(hcpreds, preds)

C = numpy.zeros((51, len(human_phenos_lookup)))
for x,y in zip(mphenos, hcpreds):
	C[x,y] += 1

pC = (C/numpy.sum(C,axis=1)[:,numpy.newaxis])

# how many cell lines were used for each pheno?
reduced_indices = (mindices-1)%48
lines_per_pheno = [set(numpy.unique(reduced_indices[mphenos==x,1])) for x in numpy.unique(mphenos)]
num_lines_per_pheno = numpy.array([len(x) for x in lines_per_pheno])
exps_per_pheno = numpy.array([len(set([tuple(z) for z in reduced_indices[mphenos==x,:]])) for x in numpy.unique(mphenos)])


import itertools
import heapq

def minimax_cluster(X):
        level = [[x] for x in range(X.shape[0])]
        bests = { x : x for x in range(X.shape[0]) }
        alive = range(X.shape[0])
        alives = []
        pairdists = []
        decisions = []
        from scipy.spatial.distance import cdist
        for a,b in itertools.combinations(alive,2):
                together = level[a]+level[b]
                D = numpy.max(cdist(X[together,:],X[together]),axis=1)
                mm = numpy.argmin(D)
                heapq.heappush(pairdists,(D[mm], (together[mm],a,b)))
        #
        toppoint = X.shape[0]
        Z = []
        while len(alive)>1:
                v, atop = heapq.heappop(pairdists)
                while ( atop[1] not in alive ) or ( atop[2] not in alive ):
                        v, atop = heapq.heappop(pairdists)
                print len(alive), len(level)
                alive = [x for x in alive if x not in [atop[1], atop[2]]]
                newish = level[atop[1]]+level[atop[2]]
                level.append(newish)
                for a in alive:
                        together = level[a]+newish
                        D = numpy.max(cdist(X[together,:],X[together]),axis=1)
                        mm = numpy.argmin(D)
                        heapq.heappush(pairdists,(D[mm], (together[mm],a, toppoint)))
                alive.append(toppoint)
                alives.append(alive)
                decisions.append((atop[1], atop[2]))
                bests[toppoint] = atop[0]
                Z.append([atop[1], atop[2], v, len(newish)])
                toppoint += 1
        #
        Z = numpy.asarray(Z)
        return Z, alives, level

Z, alives, level = minimax_cluster(pC)

chunks = [level[x] for x in alives[-18]]

chunks = [sorted(x, key=lambda x:exps_per_pheno[x], reverse=True) for x in chunks]

chunks = sorted(chunks,key=lambda x:numpy.sum(exps_per_pheno[x]), reverse=True)


[[exps_per_pheno[z] for z in x] for x in chunks]

unreduced_exps_per_pheno = numpy.array([len(set([tuple(z) for z in mindices[mphenos==x,:]])) for x in numpy.unique(mphenos)])

[[unreduced_exps_per_pheno[z] for z in x] for x in chunks]


dord = numpy.hstack(chunks)

numpy.save('dord.npy', dord)


bests = {}
for i in numpy.unique(mphenos):
	for j in numpy.unique(mphenos):
		# if i != j:
			ss = numpy.argsort(P[mphenos==i][:,j])
			bests[i,j] = numpy.where(mphenos==i)[0][ss[len(ss)/2]]

if not os.path.exists('exam_map'):
	os.mkdir('exam_map')

import Image
from scipy import ndimage
import skimage
import skimage.feature
cantdoyet = []
for ((ff,tt),ani) in bests.iteritems():
	animg = mfields[ani]
	if os.path.exists('image_cache/'+animg):
		aname = 'exam_map/'+str(ff).zfill(2)+'-'+str(tt).zfill(2)+'.png'
		if not os.path.exists(aname):
			I = numpy.array(Image.open('image_cache/'+animg))
			blurred_blue = scipy.ndimage.gaussian_filter(I[:,:,2], sigma=10)
			peaks = skimage.feature.peak_local_max(blurred_blue,min_distance=10)
			okpeaks = []
			for i in range(peaks.shape[0]):
				minx = max(0,peaks[i,0]-150) 
				maxx = min(1024,peaks[i,0]+150)
				miny = max(0,peaks[i,1]-150)
				maxy = min(1344,peaks[i,1]+150)
				if (maxx-minx)+(maxy-miny) == 600:
					okpeaks.append(i)
			if len(okpeaks)>0:
				wpeak = numpy.random.randint(len(okpeaks))
				i = okpeaks[wpeak]
				minx = max(0,peaks[i,0]-150) 
				maxx = min(1024,peaks[i,0]+150)
				miny = max(0,peaks[i,1]-150)
				maxy = min(1344,peaks[i,1]+150)
				scipy.misc.imsave(aname, I[minx:maxx, miny:maxy, :])
			else:
				cantdoyet.append((ff,tt))
	else:
		cantdoyet.append((ff,tt))

missing_in_cache = []
for (ff,tt) in cantdoyet:
	animg = mfields[bests[ff,tt]]
	if not os.path.exists('image_cache/'+animg):
		missing_in_cache.append(animg)

import ic100
import mahotas
# blue = ic100.read_ic100_BMP('round29__B___9_T_001_ch_00_image_00005_Z_001.bmp')
# green = ic100.read_ic100_BMP('round29__B___9_T_001_ch_01_image_00005_Z_001.bmp')
# zz = numpy.zeros((blue.shape[0], blue.shape[1], 3), dtype=blue.dtype)
# zz[:,:,1] = mahotas.stretch(green, 0, 2**8-1)
# zz[:,:,2] = mahotas.stretch(blue, 0, 2**8-1)

# scipy.misc.imsave('image_cache/round29__B___9_T_001_ch_00_image_00005_Z_001.bmp.png', zz)

for (ff,tt) in cantdoyet:
	aname = 'exam_map/'+str(ff).zfill(2)+'-'+str(tt).zfill(2)+'.png'
	if not os.path.exists(aname):
		animg = mfields[bests[ff,tt]]
		I = numpy.array(Image.open('image_cache/'+animg))
		blurred_blue = scipy.ndimage.gaussian_filter(I[:,:,2], sigma=10)
		peaks = skimage.feature.peak_local_max(blurred_blue,min_distance=10)
		i = numpy.random.randint(len(peaks))
		minx = peaks[i,0]-150 
		maxx = peaks[i,0]+150
		miny = peaks[i,1]-150
		maxy = peaks[i,1]+150
		if minx < 0:
			deltax = -minx
			minx += deltax
			maxx += deltax
		if miny < 0:
			deltay = -miny
			miny += deltay
			maxy += deltay
		if maxx > 1024:
			deltax = maxx-1024
			minx -= deltax
			maxx -= deltax
		if maxy > 1344:
			deltay = maxy-1344
			miny -= deltay
			maxy -= deltay
		scipy.misc.imsave(aname, I[minx:maxx, miny:maxy, :])

from PIL import Image
reord = numpy.argsort(dord)
zulu = numpy.zeros((300*51, 300*51, 3), dtype='uint8')
for i in range(0,51):
	for j in range(0,51):
		# if i != j:
			zulu[300*reord[i]:300*(reord[i]+1), 300*reord[j]:300*(reord[j]+1)] = numpy.array(Image.open('exam_map/'+str(i).zfill(2)+'-'+str(j).zfill(2)+'.png'))

# scipy.misc.imsave('preexample_map.png', zulu)

# zulu = numpy.array(Image.open('preexample_map.png'))

coffsets = numpy.cumsum([0]+[len(x) for x in chunks])

width = 16
# abox = numpy.zeros((300,300,3), dtype='uint8')
# abox[:width,:,:] = 255
# abox[-width:,:,:] = 255
# abox[:,:width,:] = 255
# abox[:,-width:,:] = 255


for a,b in zip(coffsets[:-1], coffsets[1:]):
	abox = zulu[300*a:300*b,300*a:300*b,:]
	for i,j in [(0,227), (1,74), (2, 51)]:
		abox[:width,:,i] = j
		abox[-width:,:,i] = j
		abox[:,:width,i] = j
		abox[:,-width:,i] = j


scipy.misc.imsave('example_map.png', zulu)
